<?php
/*
Plugin Name: WP Font Awesome Share Icons
Plugin URI: http://www.nitroweb.gr/
Description: Font Awesome Share Icons for Wordpress 
Author: Spyros Vlachopoulos
Version: 1.0.2
Author URI: http://www.nitroweb.gr/
*/


$wpfai_socialmedia = array(
    'facebook' => array(
      'name' => 'Facebook',
      'icon' => 'facebook',
      'link' => 'http://www.facebook.com/sharer.php?u={url}&amp;t={title}'
    ),
    'twitter' => array(
      'name' => 'Twitter',
      'icon' => 'twitter',
      'link' => 'http://twitter.com/home?status={title}%20{url}'
    ),
    'google-plus' => array(
      'name' => 'Google Plus',
      'icon' => 'google-plus',
      'link' => 'https://plus.google.com/share?url={url}'
    ),
    'pinterest' => array(
      'name' => 'Pinterest',
      'icon' => 'pinterest',
      'link' => 'http://pinterest.com/pin/create/button/?url={url}&amp;description={title}&amp;media={image}'
    ),
    'linkedin' => array(
      'name' => 'Linked In',
      'icon' => 'linkedin',
      'link' => 'http://linkedin.com/shareArticle?mini=true&amp;url={url}&amp;title={title}'
    ),
    'tumblr' => array(
      'name' => 'Tumblr',
      'icon' => 'tumblr',
      'link' => 'http://www.tumblr.com/share/link?url={url}&amp;name={title}&amp;description={excerpt}'
    ),
    'vk' => array(
      'name' => 'Vkontakte',
      'icon' => 'vk',
      'link' => 'http://vk.com/share.php?url={url}'
    ),
    'stumbleupon' => array(
      'name' => 'Stumble Upon',
      'icon' => 'stumbleupon',
      'link' => 'http://www.stumbleupon.com/submit?url={url}'
    ),
    'delicious' => array(
      'name' => 'Delicious',
      'icon' => 'delicious',
      'link' => 'http://del.icio.us/post?url={url}&amp;title={title}'
    ),
    'digg' => array(
      'name' => 'Digg',
      'icon' => 'digg',
      'link' => 'http://digg.com/submit?url={url}&amp;title={title}'
    ),
    'reddit' => array(
      'name' => 'Reddit',
      'icon' => 'reddit',
      'link' => 'http://www.reddit.com/submit?url={url}'
    ),
    'xing' => array(
      'name' => 'Xing',
      'icon' => 'xing',
      'link' => 'https://www.xing-share.com/app/user?op=share;sc_p=xing-share;url={url}'
    ),
    'envelope' => array(
      'name' => 'E-Mail',
      'icon' => 'envelope',
      'link' => "mailto:?subject={title}&amp;body={url} \n\n{excerpt}"
    )
  );

// Look... you can add your own icons without hacking my code :P
$wpfai_socialmedia = apply_filters( 'wpfai_array_filter', $wpfai_socialmedia );

add_action('admin_menu', 'wp_fai_options');

function wp_fai_options() {
    add_options_page('Font-Awesome Share', 'Font-Awesome Share', 'manage_options', 'wpfai','wpfai_options');
}

function wpfai_options() {
  global $wpfai_socialmedia;
?>
    <div class="wrap">
      <h2>Font Awesome Share Icons For Wordpress</h2>
      <form method="post" action="options.php">
        <?php wp_nonce_field('update-options') ?>
        
        <?php
          
          $alloptions = array();
        
          $regoptions = get_option('wpfai');
          $regshape = get_option('wpfai_shape');
          $reginverse = get_option('wpfai_inverse');
          $regsize = get_option('wpfai_size');
          $regloadfa = get_option('wpfai_loadfa');
          $reg_head_text = get_option('wpfai_head_text');
          $reg_place = get_option('wpfai_place');
          
          // sort array by previous saved sorting
          if (!empty($regoptions)) {
            $wpfai_socialmedia = array_merge($regoptions, $wpfai_socialmedia);
          }
          
          echo '<ul class="sociallist sortablelist">';
          foreach ($wpfai_socialmedia as $sm) {
            echo '<li class="social-item">
                <label class="social_label" for="wpfai_'. $sm['icon'] .'">
                <input id="wpfai_'. $sm['icon'] .'" type="checkbox" name="wpfai['.$sm['icon'].']" value="on" '. ($regoptions[$sm['icon']] == 'on' ? 'checked="checked"' : '') .'" />
                <div class="iconcol"><a href="#" class="wpfai-'. $sm['icon'] .'"><i class="fa fa-'. $sm['icon'] .'"></i></a></div>'. $sm['name'] .'</label> 
              </li>';
              $alloptions[] = 'wpfai['.$sm['icon'].']';
          }
          echo '</ul>';
        
        
          echo '<h3>Some more settings</h3>
          <ul class="sociallist">
            <li class="social-item">
              <label class="social_label" for="wpfai_head_text">'. __('Text Before', 'wpfai') .'</label>
              <input type="text" name="wpfai_head_text" value="'. $reg_head_text .'">
            </li>
            <li class="social-item">
              <label class="social_label" for="wpfai_shape">'. __('Shape', 'wpfai') .'</label>
              <select name="wpfai_shape">
                <option value="simple" '. ($regshape == 'simple' ? 'selected' : '') .'>'. __('Simple', 'wpfai') .'</option>
                <option value="square" '. ($regshape == 'square' ? 'selected' : '') .'>'. __('Square', 'wpfai') .'</option>
                <option value="circle" '. ($regshape == 'circle' ? 'selected' : '') .'>'. __('Circle', 'wpfai') .'</option>
              </select>
            </li>
            <li class="social-item">
              <label class="social_label" for="wpfai_inverse">'. __('Inverse', 'wpfai') .'</label>
              <select name="wpfai_inverse">
                <option value="no" '. ($reginverse == 'no' ? 'selected' : '') .'>'. __('No', 'wpfai') .'</option>
                <option value="yes" '. ($reginverse == 'yes' ? 'selected' : '') .'>'. __('Yes', 'wpfai') .'</option>
              </select>
            </li>
            <li class="social-item">
              <label class="social_label" for="wpfai_size">'. __('Size', 'wpfai') .'</label>
              <select name="wpfai_size">
                <option value="" '. ($regsize == '' ? 'selected' : '') .'></option>
                <option value="lg" '. ($regsize == 'lg' ? 'selected' : '') .'>'. __('LG', 'wpfai') .'</option>
                <option value="2x" '. ($regsize == '2x' ? 'selected' : '') .'>'. __('2x', 'wpfai') .'</option>
                <option value="3x" '. ($regsize == '3x' ? 'selected' : '') .'>'. __('3x', 'wpfai') .'</option>
                <option value="4x" '. ($regsize == '4x' ? 'selected' : '') .'>'. __('4x', 'wpfai') .'</option>
                <option value="5x" '. ($regsize == '5x' ? 'selected' : '') .'>'. __('5x', 'wpfai') .'</option>
              </select>
            </li>
            <li class="social-item">
              <label class="social_label" for="wpfai_loadfa">'. __('Load Font-Awesome Library', 'wpfai') .'</label>
              <select name="wpfai_loadfa">
                <option value="yes" '. ($regloadfa == 'yes' ? 'selected' : '') .'>'. __('Yes', 'wpfai') .'</option>
                <option value="no" '. ($regloadfa == 'no' ? 'selected' : '') .'>'. __('No', 'wpfai') .'</option>
              </select><br /><small>'. __('If you do not know, then select yes. Select no, only if you know that font-awesome is already loaded in your website.', 'wpfai') .'</small>
            </li>
            <li class="social-item">
              <label class="social_label" for="wpfai_place">'. __('Where to display', 'wpfai') .'</label>
              <select name="wpfai_place">
                <option value="no" '. ($reg_place == 'no' ? 'selected' : '') .'>'. __('Nowhere', 'wpfai') .'</option>
                <option value="after" '. ($reg_place == 'after' ? 'selected' : '') .'>'. __('After article', 'wpfai') .'</option>
                <option value="before" '. ($reg_place == 'before' ? 'selected' : '') .'>'. __('Before article', 'wpfai') .'</option>
                <option value="both" '. ($reg_place == 'both' ? 'selected' : '') .'>'. __('Before and after article', 'wpfai') .'</option>
                <option value="after_comment" '. ($reg_place == 'after_comment' ? 'selected' : '') .'>'. __('After comments', 'wpfai') .'</option>
                <option value="after_loop" '. ($reg_place == 'after_loop' ? 'selected' : '') .'>'. __('At the end of the loop', 'wpfai') .'</option>
              </select><br /><small>'. __('If you select "Nowhere", then you can use the shortcode [wpfai_social] in your posts or the code &lt;?php echo wpfai_social(); ?&gt; in your theme files', 'wpfai') .'</small>
            </li>
          </ul>
          ';
        
        $allfields = array('wpfai','wpfai_shape','wpfai_inverse','wpfai_size','wpfai_loadfa','wpfai_head_text','wpfai_place');
        ?>
        <p><input class="button button-primary" type="submit" name="Submit" value="Save Settings" /></p>
        <input type="hidden" name="action" value="update" />
        <input type="hidden" name="page_options" value="<?php echo implode(',', $allfields); ?>" />
      </form>
    </div>
    <style>
      .social_label { display: inline-block; width: 190px; }
      .social-item { margin-bottom: 3px; padding-bottom: 3px; border-bottom: 1px solid #ccc; }
      .social-item select, .social-item input[type="text"] { min-width: 200px; }
      .iconcol { width: 30px; padding-right: 5px; text-align: center; display: inline-block; }
    </style>
    <script>
      jQuery(document).ready(function(){
        jQuery( ".sortablelist" ).sortable();
      });
    </script>
<?php
}


// function to return the icons
function wpfai_social($atts = '') {
  global $wpfai_socialmedia;
  
  $output = '';

  // get all plugin options
  $regoptions = get_option('wpfai');
  $regshape = get_option('wpfai_shape');
  $reginverse = get_option('wpfai_inverse');
  $regsize = get_option('wpfai_size');
  $regloadfa = get_option('wpfai_loadfa');
  $reg_head_text = get_option('wpfai_head_text');
  $reg_place = get_option('wpfai_place');
  
  $url = esc_url($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]);
  $title = trim(wp_title('', false));
  $image = '';
  $excerpt = '';
  
  // it is a page or post or archive loop
  if (in_the_loop() && $reg_place != 'after_loop') {
    global $post;   
    
    $url = esc_url(get_permalink($post->ID));
    $title = trim(__($post->post_title, 'wpfai'));
    $img = '';
    $img = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'full' );
    $image = $img[0];
    $thetext = '';
    $thetext = strip_tags(strip_shortcodes($post->post_content));
    $excerpt = wp_trim_words(__($thetext, 'wpfai'));
  }

  $find = array('{url}', '{title}', '{image}', '{excerpt}');
  $replace = array($url, $title, $image, $excerpt);
  
  if ($reg_head_text != '') { $output .= '<h4>'. __($reg_head_text, 'wpfai') .'</h4>'; }
  
  $output .= '<ul class="wpfai-list">';
  
  foreach ($regoptions as $icon => $sm) {
  
    $output .= '<li class="wpfai-list-item '. $icon .'">
      <a href="'. str_replace($find, $replace, $wpfai_socialmedia[$icon]['link']) .'" title="'. $wpfai_socialmedia[$icon]['name'] .'" class="wpfai-'. $icon .' wpfai-link">
        <span class="fa-stack '. ($regsize != '' ? 'fa-'. $regsize : '') .'">
          '. ($regshape != 'simple' ? '<i class="fa fa-'. $regshape .''. ($reginverse == 'yes' ? '' : '-o') .' fa-stack-2x"></i>': '') .'
          <i class="fa fa-'. $icon .' fa-stack-1x '. ($reginverse == 'yes' ? 'fa-inverse' : '') .'"></i>
        </span>
      </a>
    </li>';
    
  }
  $output .= '</ul>';
  
  return ($output);
}

add_shortcode( 'wpfai_social', 'wpfai_social' );


/********** add to selected positions START **********/

function wpfai_after_content($content) { $content = $content . wpfai_social(); return $content; }
if (get_option('wpfai_place') == 'after') {  add_filter('the_content', 'wpfai_after_content'); }

function wpfai_before_content($content) { $content = wpfai_social() . $content; return $content; }
if (get_option('wpfai_place') == 'before') {  add_filter('the_content', 'wpfai_before_content'); }

function wpfai_both_content($content) { $content = wpfai_social() . $content . wpfai_social(); return $content; }
if (get_option('wpfai_place') == 'both') {  add_filter('the_content', 'wpfai_both_content'); }

function wpfai_after_comment() { echo wpfai_social(); }
if (get_option('wpfai_place') == 'after_comment') {  add_filter('comment_form_after', 'wpfai_after_comment'); }

function wpfai_after_loop() { echo wpfai_social(); }
if (get_option('wpfai_place') == 'after_loop') {  add_filter('loop_end', 'wpfai_after_loop'); }


/********** add to selected positions END **********/

// load font awesome or not
function wpfai_load_scripts () {

  if (wpfai_check_css('font-awesome.css') == 0 && wpfai_check_css('font-awesome.min.css') == 0  && get_option('wpfai_loadfa') == 'yes') {
    wp_register_style( 'wpfai_font-awesome', plugins_url( '/wp-font-awesome-share-icons/fontawesome/css/font-awesome.min.css' ) );
		wp_enqueue_style( 'wpfai_font-awesome' );
  } 
  
  wp_register_style( 'wpfai_style', plugins_url( '/wp-font-awesome-share-icons/style.css' ) );
  wp_enqueue_style( 'wpfai_style' );
  
}
add_action("wp_enqueue_scripts", "wpfai_load_scripts"); 

// load font awesome or not
function wpfai_load_admin_scripts () {

  if ($_GET['page'] == 'wpfai') {
    wp_enqueue_script("jquery-ui-core");
    wp_enqueue_script("jquery-ui-sortable");
    wp_enqueue_script("jquery-ui-draggable");
    wp_enqueue_script("jquery-ui-droppable");
    wp_register_style( 'wpfai_font-awesome', plugins_url( '/wp-font-awesome-share-icons/fontawesome/css/font-awesome.min.css' ) );
		wp_enqueue_style( 'wpfai_font-awesome' );
    wp_register_style( 'wpfai_style', plugins_url( '/wp-font-awesome-share-icons/style.css' ) );
    wp_enqueue_style( 'wpfai_style' );
  }
  
}
add_action("admin_enqueue_scripts", "wpfai_load_admin_scripts");

// check css

function wpfai_check_css($lookfor) {
  global $wp_styles;
  
  if (!empty($wp_styles->registered)) {
    foreach ($wp_styles->registered as $key => $obj) {
      if (strpos($obj->src,$lookfor) !== false || strpos($obj->src,$lookfor) !== false) { return 1; }    
    }
  }
  return 0;  
}
?>